"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = compileFunctionTypeParamMatcher;

var _Placeholder = _interopRequireDefault(require("./Placeholder"));

function compileFunctionTypeParamMatcher(path, compileOptions) {
  var pattern = path.value;
  var n = compileOptions.backend.t.namedTypes;

  if (n.GenericTypeAnnotation.check(pattern.typeAnnotation) && n.Identifier.check(pattern.typeAnnotation.id)) {
    if (pattern.typeAnnotation.typeParameters == null) {
      var placeholderMatcher = (0, _Placeholder["default"])(path, pattern.typeAnnotation.id.name, compileOptions, {
        nodeType: 'FunctionTypeParam'
      });
      if (placeholderMatcher) return placeholderMatcher;
    }
  }
}