"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = matchRegExpLiteral;

var _sortFlags = _interopRequireDefault(require("./sortFlags"));

var _ = require(".");

function matchRegExpLiteral(path, compileOptions) {
  var pattern = path.value;
  var queryFlags = (0, _sortFlags["default"])(pattern.flags);
  var n = compileOptions.backend.t.namedTypes;
  return (0, _.convertPredicateMatcher)(path, {
    match: function match(path) {
      var node = path.value;
      return n.RegExpLiteral.check(node) && node.pattern === pattern.pattern && (0, _sortFlags["default"])(node.flags) === queryFlags;
    },
    nodeType: 'RegExpLiteral'
  }, compileOptions);
}