'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

var _typeof = require('@babel/runtime/helpers/typeof')

Object.defineProperty(exports, '__esModule', {
  value: true,
})
exports['default'] = compileStringLiteralReplacement

var _Placeholder = require('../compileMatcher/Placeholder')

var _Placeholder2 = require('./Placeholder')

var _cloneNode = _interopRequireDefault(require('../util/cloneNode'))

var t = _interopRequireWildcard(require('@babel/types'))

function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null
  var cacheBabelInterop = new WeakMap()
  var cacheNodeInterop = new WeakMap()
  return (_getRequireWildcardCache = function _getRequireWildcardCache(
    nodeInterop
  ) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop
  })(nodeInterop)
}

function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj
  }

  if (
    obj === null ||
    (_typeof(obj) !== 'object' && typeof obj !== 'function')
  ) {
    return {
      default: obj,
    }
  }

  var cache = _getRequireWildcardCache(nodeInterop)

  if (cache && cache.has(obj)) {
    return cache.get(obj)
  }

  var newObj = {}
  var hasPropertyDescriptor =
    Object.defineProperty && Object.getOwnPropertyDescriptor

  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor
        ? Object.getOwnPropertyDescriptor(obj, key)
        : null

      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc)
      } else {
        newObj[key] = obj[key]
      }
    }
  }

  newObj['default'] = obj

  if (cache) {
    cache.set(obj, newObj)
  }

  return newObj
}

function compileStringLiteralReplacement(path) {
  var pattern = path.value
  var placeholder = (0, _Placeholder.getPlaceholder)(pattern.value)

  if (placeholder) {
    return {
      generate: function generate(match) {
        var _match$stringCaptures

        var captured =
          (_match$stringCaptures = match.stringCaptures) === null ||
          _match$stringCaptures === void 0
            ? void 0
            : _match$stringCaptures[placeholder]
        return captured
          ? t.stringLiteral(captured)
          : (0, _cloneNode['default'])(pattern)
      },
    }
  }

  pattern.value = (0, _Placeholder2.unescapeIdentifier)(pattern.value)
}