import Gitignore from 'gitignore-fs';
import { Minimatch } from 'minimatch';
interface FsEntry {
    name: string;
    isDirectory(): boolean;
}
export interface Fs {
    readdir(dir: string): Promise<FsEntry[]>;
    realpath(path: string): Promise<string>;
}
declare type Options = {
    include?: string;
    exclude?: string;
    includeMatcher?: Minimatch;
    excludeMatcher?: Minimatch;
    gitignore?: Gitignore | null;
    cwd?: string;
    fs?: Fs;
    visited?: Set<string>;
    nodir?: boolean;
    dot?: boolean;
};
export default function glob({ include, exclude, dot, includeMatcher, excludeMatcher, gitignore, cwd, fs, visited, ...rest }: Options): AsyncIterable<string>;
export {};
