/// <reference types="node" />
import { AstxConfig } from '../AstxConfig';
import { Transform, TransformResult } from '../Astx';
import './registerTsNode';
export interface Fs {
    readFile(file: string, encoding: string): Promise<string>;
}
export declare type RunTransformOnFileOptions = {
    file: string;
    source?: string;
    transform?: Transform;
    transformFile?: string;
    config?: Partial<AstxConfig>;
    signal?: AbortSignal;
    forWorker?: boolean;
    fs?: Fs;
};
export default function runTransformOnFile({ transform: _transform, transformFile, config: configOverrides, file, source, signal, forWorker, fs, }: RunTransformOnFileOptions): Promise<TransformResult>;
